package university;

public class Faculty extends Person {
	private int hireYear; /* year when hired */

	public Faculty(String name, int id, int hireYear) {
		super(name, id);
		this.hireYear = hireYear;
	}

	public Faculty() {
		super();
		hireYear = -1;
	}

	public Faculty(Faculty faculty) {
		/* Why are we using get methods for the first two? */
		this(faculty.getName(), faculty.getId(), faculty.hireYear);
	}

	int getHireYear() {
		check();
		return hireYear;
	}

	void setHireYear(int year) {
		hireYear = year;
	}

	public String toString() {
		return super.toString() + " " + hireYear;
	}

	public boolean equals(Object obj) {
		if (obj == this)
			return true;
		if (!(obj instanceof Faculty))
			return false;
		Faculty faculty = (Faculty) obj;

		/* Relying on Person equals; passing student */
		return super.equals(faculty) && hireYear == faculty.hireYear;
	}

	public static void main(String[] args) {
		Faculty john = new Faculty("John", 20, 2004);
		Faculty jack = new Faculty(john);
		Faculty mary = new Faculty("Mary", 101, 2010);

		System.out.println(mary);
		System.out.println("Same:" + john.equals(jack));
		System.out.println("Same:" + jack.equals(mary));

		System.out.println("Id: " + john.getId());
		System.out.println("HireYear: " + john.getHireYear());
	}
}
